package comp2402a2;

import java.util.Comparator;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;

public class FastMinStack<T> implements MinStack<T> {

  protected Comparator<? super T> comp;

  LinkedList<T> all;
  LinkedList<T> best;

  public FastMinStack() {
    this(new DefaultComparator<T>());
  }

  public FastMinStack(Comparator<? super T> comp) {
    this.comp = comp;
    all = new LinkedList<>();
    best = new LinkedList<>();
  }

  public void push(T x) {
    all.add(x);
    if (best.isEmpty() || comp.compare(x, min()) <= 0) {
      best.add(x);
    }
  }

  public T pop() {
    T x = all.remove(all.size()-1);
    if (x == min()) {
      best.remove(best.size()-1);
    }
    return x;
  }

  public T min() {
    if (best.isEmpty()) {
      return null;
    }
    return best.get(best.size()-1);
  }

  public int size() {
    return all.size();
  }

  public Iterator<T> iterator() {
    // TODO: Your code goes here
    return all.iterator();
  }

  public Comparator<? super T> comparator() {
    return comp;
  }
}
